<%@ Page language="c#" Inherits="MagSite.AdminWrite" ValidateRequest="false" EnableEventValidation="false" Codebehind="AdminWrite.aspx.cs" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML lang="ja-JP" xmlns:v="urn:schemas-microsoft-com:vml">
	<HEAD>
		<title>Rec̍쐬</title>
		<meta content="Microsoft Visual Studio .NET 7.1" name="GENERATOR">
		<meta content="C#" name="CODE_LANGUAGE">
		<meta content="JavaScript" name="vs_defaultClientScript">
		<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
		<LINK href="<% Response.Write(CssUrl); %>" type="text/css" rel="stylesheet">
		<script type="text/javascript" src="prototype.js"></script>
		<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<% Response.Write(GoogleMapsKey); %>"></script>
		<script type="text/javascript" src="gmhelper.js"></script>
		<script type="text/javascript">
			var map = null;
			var geocoder = null;

			function parseMapType(shortname) {
				switch( shortname )
				{
					case G_SATELLITE_MAP: return "a";
					case G_HYBRID_MAP: return "h";
					default: return "r";
				}			
			}

			function initialize() {
				if (GBrowserIsCompatible()) {
					map = new GMap2(document.getElementById("map_canvas"));
					var center = new GLatLng(35.68093426903065, 139.76703643798828);	// wߑł
					map.setCenter(center, 13);
					map.addControl(new GSmallMapControl());
					map.addControl(new GMapTypeControl());
					map.enableScrollWheelZoom();
					map.addControl(new GScaleControl());

					var marker = new GMarker(center);
					map.addOverlay(marker);

					GEvent.addListener(map, "moveend", function() {
						var center = map.getCenter();
						document.getElementById("message1").innerHTML = "$$gmp ,," + center.lat() + "," + center.lng() 
							 + "," + map.getZoom() + "," + parseMapType(map.getCurrentMapType());
						document.getElementById("message2").innerHTML = "," + center.lat() + "," + center.lng() + ",*,";
						marker.setLatLng(center);
					});

			        geocoder = new GClientGeocoder();
				}
			}
			function showAddress(address) {
				if (geocoder) {
					geocoder.getLatLng(
					address,
					function(point) {
						if (!point) {
						alert(address + " not found");
						} else {
						map.setCenter(point, 13);
						var marker = new GMarker(point);
						map.addOverlay(marker);
						marker.openInfoWindowHtml(address);
						}
					}
					);
				}
			}
			function activateGMPicker()
			{
				document.getElementById("map_frame").style.display = "block";
				document.getElementById("GMPickerActivator").style.display = "none";
				initialize();
			}
			function insertBodyGMP()
			{
				var elem = document.getElementById("TextBoxBody");
				elem.value = elem.value + document.getElementById("message1").innerHTML;
			}
			function insertBodyPoint()
			{
				var elem = document.getElementById("TextBoxBody");
				elem.value = elem.value + document.getElementById("message2").innerHTML;
            }
            function insertAsin(tagName,value) {
                var elem = document.getElementById("TextBoxBody");
                elem.value = "$$" + tagName + " " + value + "\r\n" + elem.value;
            }
            function searchNav(page) {
                document.getElementById("TextBoxCurrentSearchPage").value = page;
                document.getElementById("ButtonPeruSearchContinue").click();
            }
		</script>
		<!-- FlashT|[g -->
        <script language="javascript">AC_FL_RunContent = 0;</script>
        <script src="AC_RunActiveContent.js" language="javascript"></script>
		<!-- FlashT|[gI -->
	</HEAD>
	<body onunload="GUnload()">
		<form id="Form1" method="post" encType="multipart/form-data" runat="server">
			<h1>Rec̍쐬</h1>
			<div class="contentBody"><asp:label id="LabelPreview" runat="server"></asp:label></div>
			<p>L[[h:
				<asp:label id="LabelKeyword" runat="server">L[[hv[Xz_[</asp:label></p>
			<P>t:
				<asp:textbox id="TextBoxYear" runat="server" Width="4em"></asp:textbox>N
				<asp:textbox id="TextBoxMonth" runat="server" Width="2em"></asp:textbox>
				<asp:textbox id="TextBoxDay" runat="server" Width="2em"></asp:textbox>
				<asp:textbox id="TextBoxHour" runat="server" Width="2em"></asp:textbox>
				<asp:textbox id="TextBoxMinute" runat="server" Width="2em"></asp:textbox>
				<asp:textbox id="TextBoxSecond" runat="server" Width="2em"></asp:textbox>b</P>
			<P>^Cg:
				<asp:textbox id="TextBoxTitle" runat="server" Width="43em"></asp:textbox></P>
			<P>{:
				<asp:DropDownList id="DropDownListBodyType" runat="server">
					<asp:ListItem Value="PlaneText">v[eLXg</asp:ListItem>
					<asp:ListItem Value="MagML" Selected="True">MagML</asp:ListItem>
					<asp:ListItem Value="XHTML">XHTML</asp:ListItem>
				</asp:DropDownList><asp:button id="ButtonPreview2" runat="server" Text="mF" onclick="ButtonPreview2_Click"></asp:button>
                <asp:Button ID="ButtonFixParams" runat="server" onclick="ButtonFixParams_Click" 
                    Text="" />
                <asp:button id="ButtonToXhtml" runat="server" Text="XHTML" onclick="ButtonToXhtml_Click"></asp:button><asp:button id="ButtonSaveDraft" runat="server" Text="ۊǂĒf" onclick="ButtonSaveDraft_Click"></asp:button><asp:button id="ButtonDispose" runat="server" Text="jďI" onclick="ButtonDispose_Click"></asp:button></P>
			<P><asp:textbox id="TextBoxBody" runat="server" Width="48em" Height="16em" TextMode="MultiLine"></asp:textbox></P>
			<P><asp:button id="ButtonPreview" runat="server" Text="mF" onclick="ButtonPreview_Click"></asp:button></P>
			<P class="specialButton"><asp:button id="ButtonWrite" runat="server" Width="20em" Text="" onclick="ButtonWrite_Click"></asp:button></P>
			<p class="boxed"><asp:label id="LabelSupplyMessage" runat="server">⏕bZ[Wv[Xz_[</asp:label></p>
<h2>Amazoni</h2>
        <asp:DropDownList ID="DropDownListPeruSearchIndex" runat="server">
        </asp:DropDownList>
        <asp:TextBox ID="TextBoxPeruSearchKeyword" runat="server" Width="425px" onKeyPress="if( event.keyCode == 13){ document.getElementById('ButtonPeruSearchKW').click();return false;}"></asp:TextBox>
             <asp:Button ID="ButtonPeruSearchKW"
                runat="server" Text="" onclick="ButtonPeruSearchKW_Click" />
            <asp:TextBox ID="TextBoxCurrentSearchPage" runat="server" 
                CssClass="forceHidden"></asp:TextBox>

			<asp:Button ID="ButtonPeruSearchContinue" runat="server" CssClass="forceHidden" 
                onclick="ButtonPeruSearchContinue_Click" Text="p" />

			<div class="horizontalLine"></div>
			<h2>Ytt@C̒ǉ</h2>
			<p>t@C̐:
				<asp:textbox id="TextBoxFileTitle" runat="server" Width="40em"></asp:textbox></p>
			<p>Mt@C̃tpX: <input id="FileUpload" style="WIDTH: 456px; HEIGHT: 22px" type="file" size="56" name="File1"
					runat="server">&nbsp;
				<asp:button id="ButtonSendFile" runat="server" Text="M" onclick="ButtonSendFile_Click"></asp:button></p>
			<p class="boxed">gq.jpg, .png, .gif, .bmp̂ꂩ̃t@Cǉꍇ͉摜t@CƂȂ܂B 
				.bmp.pngɎϊ܂B 
				̑̃t@ĆAʂ̓Ytt@CɂȂ܂BYtt@C̍őTCY͕WԂł͖4KoCgłBőTCY𒴂t@C𑗐M悤ƂƃT[o͉s킸AG[\ƂȂ܂B</p>
			<h2>t@C̊Ǘ</h2>
			<p>̃Recɑt@Cꗗ:</p>
			<P><asp:listbox id="ListBoxFiles" runat="server" Width="48em"></asp:listbox></P>
			<P><asp:button id="ButtonFileDelete" runat="server" Text="It@C̍폜" onclick="ButtonFileDelete_Click"></asp:button></P>
			<P>VO:
				<asp:textbox id="TextBoxFileNewName" runat="server"></asp:textbox><asp:button id="ButtonChangeNameOfFile" runat="server" Text="It@C̖OVOɕύX" onclick="ButtonChangeNameOfFile_Click"></asp:button></P>
			<div class="horizontalLine"></div>
			<asp:Panel id="PanelPeruMenu" runat="server">
				<asp:Label id="LabelPeruMenu" runat="server"></asp:Label>
				<P>
					<asp:Label id="LabelPeruCode1" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin1" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode2" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin2" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode3" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin3" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode4" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin4" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode5" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin5" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode6" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin6" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode7" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin7" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode8" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin8" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode9" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin9" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode10" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin10" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode11" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin11" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode12" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin12" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode13" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin13" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode14" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin14" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode15" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin15" runat="server"></asp:textbox></P>
				<P>
					<asp:Label id="LabelPeruCode16" runat="server"></asp:Label>:
					<asp:textbox id="PeruAsin16" runat="server"></asp:textbox></P>
			</asp:Panel>
			<div class="horizontalLine"></div>
			<h2>gbNobN</h2>
			<p>gbNobNMΏۂƂȂgbNobNURL (1s1URLLq):</p>
			<p>
				<asp:TextBox id="TextBoxWaitingTrackBacks" runat="server" Width="48em" TextMode="MultiLine" Height="5em"></asp:TextBox></p>
			<p>ߋɑMG[ŃyfBOw肳ꂽgbNobNꗗ:</p>
			<P><asp:listbox id="ListboxPendingTrackBacks" runat="server" Width="48em"></asp:listbox></P>
			<P><asp:button id="ButtonDeletePendingTrackBack" runat="server" Text="IyfBOURL̍폜" onclick="ButtonDeletePendingTrackBack_Click"></asp:button><asp:button id="ButtonResendPendingTrackBack" runat="server" Text="IyfBOURLēxgbNobNMΏۂ" onclick="ButtonResendPendingTrackBack_Click"></asp:button></P>
			<p>Mς݃gbNobNꗗ:</p>
			<P><asp:listbox id="ListboxAlreadySentTrackBacks" runat="server" Width="48em"></asp:listbox></P>
			<div class="horizontalLine"></div>
		</form>
		<p><a id="GMPickerActivator" href="javascript:activateGMPicker();">GoogleMapsWsbJ[J</a></p>
		<div id="map_frame" style="display:none">
		    <form action="#" onsubmit="showAddress(this.address.value); return false">
			<p>
				<input type="text" size="60" name="address" value="" />
				<input type="submit" value="n}" />
			</p>
			<div id="map_canvas" style="width: 500px; height: 300px"></div>
		    <div><span id="message1"></span>
		    <input type="button" id="insertPoint1" value="gmpǉ" onclick="javascript:insertBodyGMP();">
		    </div>
		    <div><span id="message2"></span>
		    <input type="button" id="insertPoint2" value="Wǉ" onclick="javascript:insertBodyPoint();">
		    </div>
			</form>
		</div>


	</body>
</HTML>
