#define QUICK_HACK_FOR_RECOMPILATION

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Xml;
using System.Xml.Linq;
using AWebProcedureFramework;
using MagSiteLib;
using NestedHtmlWriter;

namespace MagSite
{
    /// <summary>
    /// AdminWrite ̊Tv̐łB
    /// </summary>
    public partial class AdminWrite : System.Web.UI.Page
    {

        #region Web tH[ fUCiŐꂽR[h
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
            //
            InitializeComponent();
            base.OnInit(e);
        }

        /// <summary>
        /// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
        /// R[h GfB^ŕύXȂłB
        /// </summary>
        private void InitializeComponent()
        {

        }
        #endregion

        public string CssUrl = "default.css";
        public string GoogleMapsKey = "";
        private FullKeyword keyword = FullKeyword.NoKeyword;
        private ItemID handlingItemID = ItemID.NoItem;
        private System.Web.UI.WebControls.TextBox[] peruAsins()
        {
            return new System.Web.UI.WebControls.TextBox[16]
				{
					PeruAsin1,
					PeruAsin2,
					PeruAsin3,
					PeruAsin4,
					PeruAsin5,
					PeruAsin6,
					PeruAsin7,
					PeruAsin8,
					PeruAsin9,
					PeruAsin10,
					PeruAsin11,
					PeruAsin12,
					PeruAsin13,
					PeruAsin14,
					PeruAsin15,
					PeruAsin16,
				};
        }

        private bool editMode
        {
            get
            {
                return handlingItemID.IsDuplicatedDraftItemID();
            }
        }

        private void setMessage(string partialTag, string message)
        {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            StringReader reader = new StringReader(message);
            while (true)
            {
                string s = reader.ReadLine();
                if (s == null) break;
                sb.Append("<p");
                sb.Append(partialTag);
                sb.Append(">");
                sb.Append(HttpUtility.HtmlEncode(s));
                sb.Append("</p>\r\n");
            }
            this.LabelPreview.Text = sb.ToString();
        }

        private void setErrorMessage(string s)
        {
            setMessage(" class=\"error\"", s);
        }

        private void setNormalMessage(string s)
        {
            setMessage("", s);
        }

        private EBodyType getBodyType()
        {
            switch (DropDownListBodyType.SelectedValue)
            {
                case "PlaneText":
                    return EBodyType.PlaneText;
                case "MagML":
                    return EBodyType.MagML;
                case "XHTML":
                    return EBodyType.XhtmlByText;
            }
            throw new ApplicationException(DropDownListBodyType.SelectedValue + "͉߂łȂ{^łB");
        }

        private int getIntegerValue(string s, int min, int max, string label)
        {
            int r;
            try
            {
                r = int.Parse(s);
            }
            catch (FormatException e)
            {
                throw new FormatException(label + "" + min.ToString() + "ȏA" + max.ToString() + "ȉ̐łȂ΂Ȃ܂B", e);
            }
            if (r < min || r > max)
            {
                throw new FormatException(label + "" + min.ToString() + "ȏA" + max.ToString() + "ȉ̐łȂ΂Ȃ܂B");
            }
            return r;
        }

        private void redirectToAdminMainPage()
        {
            Response.Redirect(WriteLib.BuildUrlToAdminMainPage(keyword));
        }

        private void redirectToSendingTrackBackProcedure(ItemID targetItemID)
        {
#if QUICK_HACK_FOR_RECOMPILATION
            Response.Redirect(FileNames.AdminFn + "?fn=tbwait&id=" + targetItemID.ID);
#else
			Response.Redirect(WriteLib.BuildUrlToSendingTrackBackProcedure(TrackBackProcedure.TrackBackSendWebProcItem,targetItemID) );
#endif
        }

        private DateTime getDateTime()
        {
            int year = getIntegerValue(this.TextBoxYear.Text, 2, 9999, "N");
            int month = getIntegerValue(this.TextBoxMonth.Text, 1, 12, "");
            int day = getIntegerValue(this.TextBoxDay.Text, 1, 31, "");
            int hour = getIntegerValue(this.TextBoxHour.Text, 0, 23, "");
            int minute = getIntegerValue(this.TextBoxMinute.Text, 0, 59, "");
            int second = getIntegerValue(this.TextBoxSecond.Text, 0, 59, "b");
            return new DateTime(year, month, day, hour, minute, second);
        }

        private void setDateTimeFields()
        {
            DateTime now = DateTime.Now;
            this.TextBoxYear.Text = now.Year.ToString();
            this.TextBoxMonth.Text = now.Month.ToString();
            this.TextBoxDay.Text = now.Day.ToString();
            this.TextBoxHour.Text = now.Hour.ToString();
            this.TextBoxMinute.Text = now.Minute.ToString();
            this.TextBoxSecond.Text = now.Second.ToString();
        }

        private int allocateNewFileNumber()
        {
            int number = 0;
            foreach (ListItem listItem in this.ListBoxFiles.Items)
            {
                try
                {
                    if (number < Item.AttachedFile.ParseNumber(listItem.Text))
                    {
                        number = Item.AttachedFile.ParseNumber(listItem.Text);
                    }
                }
                catch (System.InvalidOperationException)
                {
                    // ignore it
                }
            }
            return number + 1;
        }

        private bool isInvalidChar(char ch)
        {
            if (ch == 0x0d || ch == 0x0a || ch == 0x09) return false;
            if (ch < 0x20)
            {
                return true;
            }
            if (ch >= 0xfffd && ch <= 0xffff)
            {
                return true;
            }
            return false;
        }

        private bool fixControlCode(System.Web.UI.WebControls.TextBox textbox, string title)
        {
            string src = textbox.Text;
            bool invalid = false;
            foreach (char ch in src)
            {
                if (isInvalidChar(ch))
                {
                    invalid = true;
                    break;
                }
            }
            if (!invalid) return false;

            System.Text.StringBuilder message = new System.Text.StringBuilder();
            message.AppendFormat("{0}̐䕶󔒕ɒu܂B(: ȉ̕̕\L͖ڈł)\r\n", title);
            System.Text.StringBuilder result = new System.Text.StringBuilder();
            foreach (char ch in src)
            {
                if (isInvalidChar(ch))
                {
                    message.AppendFormat("{0}ڂ{1,8:x4}𔼊p󔒕ɒu܂B\r\n", message.Length, (int)ch);
                    result.Append(' ');
                }
                else
                {
                    result.Append(ch);
                }
            }
            textbox.Text = result.ToString();
            setErrorMessage(message.ToString());
            return true;
        }

        private void updateAdditionalTitle(Item item)
        {
            SectionDef def = SectionDefManager.GetSectionDef(item.Keyword);
            item.AdditionalTitle = WriteLib.GetAdditionalTitle(item, def.PeruAssociateID);
        }

        private bool validation()
        {
            this.updateItemWithoutAttachedFiles(this.handlingItemID);

            // XHTML[h̏ꍇ̂݁A^Cg͕K{
            if (this.getBodyType() == EBodyType.XhtmlByText && this.TextBoxTitle.Text.Trim().Length == 0)
            {
                setErrorMessage("^Cg͂Ă܂B");
                return false;
            }
            if (this.TextBoxBody.Text.Trim().Length == 0)
            {
                setErrorMessage("{͂Ă܂B");
                return false;
            }

            if (fixControlCode(this.TextBoxTitle, "^Cg")) return false;
            if (fixControlCode(this.TextBoxBody, "{")) return false;
            if (fixControlCode(this.TextBoxWaitingTrackBacks, "gbNobNMΏۂƂȂgbNobNURL")) return false;

            foreach (System.Web.UI.WebControls.TextBox peruAsin in this.peruAsins())
            {
                if (fixControlCode(peruAsin, "ASINR[h")) return false;
            }

            if (this.getBodyType() == EBodyType.XhtmlByText)
            {
                try
                {
                    if (!this.TextBoxBody.Text.Trim().StartsWith("<div>"))
                    {
                        this.TextBoxBody.Text = "<div>" + this.TextBoxBody.Text;
                    }
                    if (!this.TextBoxBody.Text.Trim().EndsWith("</div>"))
                    {
                        this.TextBoxBody.Text = this.TextBoxBody.Text + "</div>";
                    }

                    XmlDocument doc = new XmlDocument();
                    doc.LoadXml(this.TextBoxBody.Text);
                }
                catch (XmlException e2)
                {
                    setErrorMessage(e2.Message);
                    return false;
                }
            }

            bool returnResult = true;
            try
            {
                this.LabelPreview.Text = "";

                Item draftItem = DraftManager.GetItem(this.handlingItemID);
                string body = this.TextBoxBody.Text;
                string title = this.TextBoxTitle.Text;
                EBodyType bodyType = this.getBodyType();
                if (title.Trim().Length == 0 && bodyType != EBodyType.MagML && !body.StartsWith("$$asinr"))
                {
                    var reader = new StringReader(body);
                    title = reader.ReadLine();  // Õ`FbNɂ菭ȂƂ1s͂͂
                    body = reader.ReadToEnd();  // ̃\bh͋̏ꍇł󕶎Ԃ
                }
                if (bodyType == EBodyType.MagML)
                {
                    MagAttachedFileInformations info = new MagAttachedFileInformations(this.handlingItemID,
                        draftItem.AttachedFiles);
                    MagML magML = new MagML();
                    magML.Compile(body, info, false, true);
                    body = magML.RenderedBody;
                    bodyType = EBodyType.XhtmlByText;
                    returnResult = !magML.EncountedError;
                    if (magML.EncountedError)
                    {
                        setErrorMessage("MagML̋LqG[o܂B̃RecނƂ͂ł܂B");
                    }
                }
                this.LabelPreview.Text += WriteLib.BuildPreviewXhtmlFragment(this.handlingItemID,
                    WriteLib.BuildSubject(title, draftItem.AdditionalTitle),
                    getDateTime(), this.keyword, body,
                    draftItem.AttachedFiles,
                    draftItem.AllPeruAsin,
                    bodyType == EBodyType.XhtmlByText);
            }
            catch (FormatException e2)
            {
                setErrorMessage(e2.Message);
                return false;
            }
            return returnResult;
        }

        private void textboxWaitingTrackBacksIntoItem(Item item)
        {
            StringReader reader = new StringReader(this.TextBoxWaitingTrackBacks.Text);
            item.ClearWaitingTrackBackUrls();
            while (true)
            {
                string s = reader.ReadLine();
                if (s == null) break;
                if (s.Trim().Length > 0)
                {
                    item.AddWaitingTrackBackUrl(s.Trim());
                }
            }
        }

        private void updateItemWithoutAttachedFiles(ItemID targetNewItemID)
        {
            Item item = DraftManager.GetItem(handlingItemID);
            lock (item)
            {
                item.BodyType = getBodyType();

                item.Body = this.TextBoxBody.Text;
                item.Subject = this.TextBoxTitle.Text;
                if (item.Subject.Trim().Length == 0 && item.BodyType != EBodyType.MagML && !item.Body.StartsWith("$$asinr"))
                {
                    var reader = new StringReader(item.Body);
                    item.Subject = reader.ReadLine();  // Õ`FbNɂ菭ȂƂ1s͂͂
                    item.Body = reader.ReadToEnd();  // ̃\bh͋̏ꍇł󕶎Ԃ
                }

                item.PeruAsin.Clear();
                foreach (System.Web.UI.WebControls.TextBox peruAsin in this.peruAsins())
                {
                    if (peruAsin.Text.Trim().Length > 0)
                    {
                        item.PeruAsin.Add(Isbn.ConvertTo10(peruAsin.Text.Trim()));
                    }
                }

                if (item.BodyType == EBodyType.MagML)
                {
                    MagAttachedFileInformations info = new MagAttachedFileInformations(targetNewItemID,
                        item.AttachedFiles);
                    MagML magML = new MagML();
                    magML.Compile(item.Body, info, false);
                    item.RenderedBody = magML.RenderedBody;
                    item.RenderedDate = DateTime.Now;
                    item.RendererName = MagML.RendererName;
                    item.SetCategoryNames(WriteLib.CreateCategoryFullList(item, magML.Categories));
                    item.EmbeddedPeruAsin.Clear();
                    item.RepresentPeruAsin.Clear();
                    foreach (string asin in magML.EmbeddedAsins) item.EmbeddedPeruAsin.Add(Isbn.ConvertTo10(asin));
                    foreach (string asin in magML.RepresentAsins) item.RepresentPeruAsin.Add(Isbn.ConvertTo10(asin));
                    updateAdditionalTitle(item);
                }
                else
                {
                    item.RenderedBody = "";
                    item.RenderedDate = DateTime.MinValue;
                    item.RendererName = "";
                    item.SetCategoryNames(WriteLib.CreateCategoryFullList(item, new ArrayList()));
                    item.EmbeddedPeruAsin.Clear();
                    item.RepresentPeruAsin.Clear();
                }

                textboxWaitingTrackBacksIntoItem(item);

                item.Update();
            }
        }

        private const string fileTitleRequestMessage = "(ꂩAbv[ht@C̐͂ĉ [K{])";
        private void initializeUpload()
        {
            this.TextBoxFileTitle.Text = fileTitleRequestMessage;
        }

        private void updateListBoxFiles()
        {
            Item item = DraftManager.GetItem(handlingItemID);
            lock (item)
            {
                this.ListBoxFiles.Items.Clear();
                foreach (Item.AttachedFile attachedFile in item.AttachedFiles)
                {
                    this.ListBoxFiles.Items.Add(attachedFile.ToString());
                }
            }
        }

        private void updateListboxPendingTrackBacks()
        {
            Item item = DraftManager.GetItem(handlingItemID);
            lock (item)
            {
                this.ListboxPendingTrackBacks.Items.Clear();
                foreach (string s in item.GetPendingTrackBackUrls())
                {
                    this.ListboxPendingTrackBacks.Items.Add(s);
                }
            }
        }

        private void updateListboxAlreadySentTrackBacks()
        {
            Item item = DraftManager.GetItem(handlingItemID);
            lock (item)
            {
                this.ListboxAlreadySentTrackBacks.Items.Clear();
                foreach (string s in item.GetAlreadySentTrackBackUrls())
                {
                    this.ListboxAlreadySentTrackBacks.Items.Add(s);
                }
            }
        }

        private void updateTextBoxWaitingTrackBacks(Item item)
        {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            foreach (string s in item.GetWaitingTrackBackUrls())
            {
                sb.Append(s);
                sb.Append("\r\n");
            }
            this.TextBoxWaitingTrackBacks.Text = sb.ToString();
        }

        private void updatePeruSearchIndex()
        {
            this.DropDownListPeruSearchIndex.Items.Clear();
            StringReader reader = new StringReader(MagSiteLib.PeruSearchUtil.GetPeruSearchIndexes());
            for (; ; )
            {
                string s = reader.ReadLine();
                if (s == null) break;
                if (s.Trim().Length == 0) continue;
                this.DropDownListPeruSearchIndex.Items.Add(s.Trim());
            }
        }

        private void onFirstPageLoaded()
        {
            System.Diagnostics.Debug.Assert(!handlingItemID.IsNoItem());

            Item item;
            if (handlingItemID.IsDraftItemID())
            {
                this.LabelSupplyMessage.Text = HttpUtility.HtmlEncode("̃y[W̃{^g킸̃y[WɈړƁA"
                    + "Ōɂ̃y[Wǂݍ܂ꂽ_̓eA쐬RecƂĕۊǂ܂B"
                    + "ۊǂȂꍇ́AujďIv{^ĉB");
                item = DraftManager.GetItem(handlingItemID);
            }
            else
            {
                this.LabelSupplyMessage.Text = HttpUtility.HtmlEncode("̃Rec̓eCł܂B"
                    + "CɏIꍇ́AujďIv{^ĉB");
                item = ContentFileAccessLayer.GetItem(handlingItemID);
            }
            lock (item)
            {
                this.TextBoxBody.Text = item.Body;
                this.TextBoxTitle.Text = item.Subject;
                switch (item.BodyType)
                {
                    case EBodyType.PlaneText:
                        this.DropDownListBodyType.SelectedValue = "PlaneText";
                        break;
                    case EBodyType.XhtmlByText:
                        this.DropDownListBodyType.SelectedValue = "XHTML";
                        break;
                    case EBodyType.XhtmlFragment:
                        this.DropDownListBodyType.SelectedValue = "XHTML";
                        break;
                    case EBodyType.MagML:
                        this.DropDownListBodyType.SelectedValue = "MagML";
                        break;
                }

                System.Web.UI.WebControls.TextBox[] asins = this.peruAsins();
                foreach (System.Web.UI.WebControls.TextBox peruAsin in asins)
                {
                    peruAsin.Text = "";
                }
                for (int i = 0; i < Math.Min(asins.Length, item.PeruAsin.Count); i++)
                {
                    if (item.PeruAsin[i].Trim().Length > 0)
                    {
                        asins[i].Text = item.PeruAsin[i].Trim();
                    }
                }

                if (handlingItemID.IsUnderConstructionDraftItemID())
                {
                    setDateTimeFields();
                }
                else
                {
                    this.TextBoxYear.Text = (item.Date.Year % 5000).ToString();
                    this.TextBoxMonth.Text = item.Date.Month.ToString();
                    this.TextBoxDay.Text = item.Date.Day.ToString();
                    this.TextBoxHour.Text = item.Date.Hour.ToString();
                    this.TextBoxMinute.Text = item.Date.Minute.ToString();
                    this.TextBoxSecond.Text = item.Date.Second.ToString();

                    this.TextBoxYear.Enabled = false;
                    this.TextBoxMonth.Enabled = false;
                    this.TextBoxDay.Enabled = false;
                    this.TextBoxHour.Enabled = false;
                    this.TextBoxMinute.Enabled = false;
                    this.TextBoxSecond.Enabled = false;
                }

                updateTextBoxWaitingTrackBacks(item);
            }

            LabelKeyword.Text = WriteLib.KeywordToHumanReadableString(keyword);
            this.LabelPreview.Text = HttpUtility.HtmlEncode("mF{^ĊmFĂB");
            this.ButtonSaveDraft.Visible = handlingItemID.IsDraftItemID();
            initializeUpload();
        }

        protected void Page_Load(object sender, System.EventArgs e)
        {
#if KINOLABO
			this.PanelPeruMenu.Visible = false;
#endif

            System.Web.UI.WebControls.Label[] labelPeruCodes = 
				{
					this.LabelPeruCode1,
					this.LabelPeruCode2,
					this.LabelPeruCode3,
					this.LabelPeruCode4,
					this.LabelPeruCode5,
					this.LabelPeruCode6,
					this.LabelPeruCode7,
					this.LabelPeruCode8,
					this.LabelPeruCode9,
					this.LabelPeruCode10,
					this.LabelPeruCode11,
					this.LabelPeruCode12,
					this.LabelPeruCode13,
					this.LabelPeruCode14,
					this.LabelPeruCode15,
					this.LabelPeruCode16
			   };

            this.LabelPeruMenu.Text = SpecialResource.PeruWriteMenu;
            foreach (System.Web.UI.WebControls.Label label in labelPeruCodes)
            {
                label.Text = SpecialResource.PeruCode;
            }

            this.handlingItemID = URIQueryParser.ParseID(Request.Params);
            if (this.handlingItemID.IsNoItem())
            {
                ItemID newItemID = DraftManager.ReserveDraftID(URIQueryParser.ParseKeyword(Request.Params));
                string myselfWithID = Request.FilePath;
                myselfWithID = myselfWithID + "?id=" + newItemID.ID;
                Response.Redirect(myselfWithID);
                return;
            }
            else if (this.handlingItemID.IsNormalItemID() || this.handlingItemID.IsAboutKeywordItemID() || this.handlingItemID.IsCommonNoticeItemID())
            {
                ItemID newItemID = handlingItemID.ToDuplicatedDraftItemID();
                if (DraftManager.IsExist(newItemID))
                {
                    DraftManager.Remove(newItemID);
                }
                Item item = ContentFileAccessLayer.GetItem(handlingItemID);
                DraftManager.AddDumplicatedDraftItem(item, newItemID);
                string myselfWithID = Request.FilePath;
                myselfWithID = myselfWithID + "?id=" + newItemID.ID;
                Response.Redirect(myselfWithID);
                return;
            }
            this.keyword = GeneralContentsHandler.GetItem(this.handlingItemID).Keyword;
            SectionDef def = SectionDefManager.GetSectionDef(this.keyword);
            this.CssUrl = def.StyleSheetURI;
            this.GoogleMapsKey = def.GoogleMapsKey;

            Authorization.ConfirmAccessPermission(User.Identity.Name, this.keyword);

            System.Diagnostics.Debug.Assert(!handlingItemID.IsNoItem());
            System.Diagnostics.Debug.Assert(!handlingItemID.IsNormalItemID());
            System.Diagnostics.Debug.Assert(!handlingItemID.IsAboutKeywordItemID());
            System.Diagnostics.Debug.Assert(!handlingItemID.IsCommonNoticeItemID());

            if (!this.IsPostBack)
            {
                onFirstPageLoaded();
                updateListBoxFiles();
                updateListboxPendingTrackBacks();
                updateListboxAlreadySentTrackBacks();
                updatePeruSearchIndex();
            }
        }

        protected void Page_Unload(object sender, System.EventArgs e)
        {
            if (this.handlingItemID.IsDraftItemID())
            {
                updateItemWithoutAttachedFiles(this.handlingItemID);
            }
        }

        protected void ButtonPreview_Click(object sender, System.EventArgs e)
        {
            validation();
        }

        protected void ButtonPreview2_Click(object sender, System.EventArgs e)
        {
            validation();
        }

        protected void ButtonSaveDraft_Click(object sender, System.EventArgs e)
        {
            redirectToAdminMainPage();
        }

        protected void ButtonDispose_Click(object sender, System.EventArgs e)
        {
            DraftManager.Remove(handlingItemID);
            handlingItemID = ItemID.NoItem;
            redirectToAdminMainPage();
        }

        protected void ButtonWrite_Click(object sender, System.EventArgs e)
        {
            bool valid = validation();
            if (!valid) return;

            ItemID targetItemID = ItemID.NoItem;
            try
            {
                if (handlingItemID.IsUnderConstructionDraftItemID())
                {
                    targetItemID = new ItemID(getDateTime());
                    this.updateItemWithoutAttachedFiles(targetItemID);

                    General.AddItemFromUnderConstructionDraftItem(handlingItemID, targetItemID);
                    handlingItemID = ItemID.NoItem;

                    sendAdministrator(targetItemID);
                    sendAutoReport(targetItemID);

                    setNormalMessage("Recǉ");
                }
                else if (handlingItemID.IsDuplicatedDraftItemID())
                {
                    targetItemID = handlingItemID.ToNormalItemID();
                    if (!ContentFileAccessLayer.IsExist(targetItemID))
                    {
                        setErrorMessage("݂ȂRecIDw肳Ă܂B邱Ƃ͂ł܂B");
                        return;
                    }
                    this.updateItemWithoutAttachedFiles(targetItemID);

                    General.ReplaceItemWithDuplicatedDraftItem(handlingItemID, targetItemID);
                    handlingItemID = ItemID.NoItem;

                    sendAdministrator(targetItemID);
                    sendAutoReport(targetItemID);

                    setNormalMessage("RecXV");
                }
                else
                {
                    // ɏP[X͒ʏ킠蓾ȂASƂĈȉ̍su
                    throw new ApplicationException("ȃRecIDw肳Ă܂BނƂ͂ł܂B");
                }
#if false
				this.TextBoxBody.Text = "";
				this.TextBoxTitle.Text = "";
				this.DropDownListBodyType.SelectedIndex = 0;
				foreach( System.Web.UI.WebControls.TextBox peruAsin in this.peruAsins() )
				{
					peruAsin.Text = "";
				}
				setDateTimeFields();
#endif
            }
            catch (Exception e2)
            {
                System.Text.StringBuilder sb = new System.Text.StringBuilder();
                Exception t = e2;
                while (true)
                {
                    if (t == null) break;
                    sb.Append(t.Message);
                    sb.Append("\r\n");
                    t = t.InnerException;
                }

                if (handlingItemID.IsNoItem())
                {
                    Response.Redirect(FileNames.AdminFn + "?msg=" + HttpUtility.UrlEncode("vIȃG[: " + sb.ToString()) + "&" + WriteLib.BuildKeywordParameter(keyword));
                }
                else
                {
                    setErrorMessage(sb.ToString());
                }
                return;
            }

            if (GeneralContentsHandler.GetItem(targetItemID).GetWaitingTrackBackUrls().Count == 0)
            {
                redirectToAdminMainPage();
            }
            else
            {
                redirectToSendingTrackBackProcedure(targetItemID);
            }
        }

        protected void ButtonToXhtml_Click(object sender, System.EventArgs e)
        {
            if (this.DropDownListBodyType.SelectedValue == "XHTML")
            {
                setErrorMessage("XHTMLɂȂĂ܂B͍s܂łB");
                return;
            }
            if (this.DropDownListBodyType.SelectedValue == "MagML")
            {
                MagAttachedFileInformations info = new MagAttachedFileInformations(this.handlingItemID,
                    DraftManager.GetItem(this.handlingItemID).AttachedFiles);
                MagML magML = new MagML();
                magML.Compile(this.TextBoxBody.Text, info, false);
                if (magML.EncountedError)
                {
                    setErrorMessage("MagMLɃG[܂܂܂B͍s܂łB"
                        + "mF{^NbNāAG[emFĉB");
                    return;
                }
                this.TextBoxBody.Text = magML.RenderedBody;
                foreach (string asin in magML.EmbeddedAsins)
                {
                    // 󂫂Aߍ܂ꂽASINR[h͓]LĂ݂悤
                    // ܁ACx߂
                    var asinControls = this.peruAsins();
                    foreach (System.Web.UI.WebControls.TextBox tb in asinControls)
                    {
                        if (tb.Text.Trim().Length == 0)
                        {
                            tb.Text = asin;
                            break;
                        }
                    }
                }
                foreach (string asin in magML.RepresentAsins)
                {
                    // 󂫂Aߍ܂ꂽASINR[h͓]LĂ݂悤
                    // ܁ACx߂
                    var asinControls = this.peruAsins();
                    foreach (System.Web.UI.WebControls.TextBox tb in asinControls)
                    {
                        if (tb.Text.Trim().Length == 0)
                        {
                            tb.Text = asin;
                            break;
                        }
                    }
                }
            }
            else
            {
                using (StringWriter writer = new StringWriter())
                {
                    using (StringReader reader = new StringReader(this.TextBoxBody.Text))
                    {
                        using (NhDiv div = new NhDiv(writer, null))
                        {
                            while (true)
                            {
                                string s = reader.ReadLine();
                                if (s == null) break;
                                div.WritePText(s);
                            }
                        }
                    }
                    this.TextBoxBody.Text = writer.ToString();
                }
            }
            this.DropDownListBodyType.SelectedValue = "XHTML";
        }

        private void sendAdministrator(ItemID itemID)
        {
            Item item = ContentFileAccessLayer.GetItem(itemID);
            SectionDef def = SectionDefManager.GetSectionDef(item.Keyword);

            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            sb.Append(def.Title);
            if (editMode)
            {
                sb.Append("̃RecXV܂B\r\n");
            }
            else
            {
                sb.Append("ɃRec܂܂B\r\n");
            }
            sb.Append("\r\n");
            sb.Append("ID: ");
            sb.Append(itemID.ToString());
            sb.Append("\r\n");
            sb.Append("Subject: ");
            sb.Append(item.SubjectFull);
            sb.Append("\r\n");
            sb.Append("Keyword: ");
            sb.Append(WriteLib.KeywordToHumanReadableString(item.Keyword));
            sb.Append("\r\n");
            sb.Append("\r\n");
            sb.Append("Sȓe͓Ytt@C̒ʂłB\r\n");
            sb.Append("\r\n");
            sb.Append(MagSiteLib.Version.PoweredByFullName);
            sb.Append("\r\n");

            ArrayList fileNameList = new ArrayList();
            fileNameList.Add(FileLayout.GetContentFileName(itemID, item.Keyword));
            foreach (Item.AttachedFile attachedFile in item.AttachedFiles)
            {
                fileNameList.Add(FileLayout.GetAttachedFileName(itemID, attachedFile.FileName));
            }

            MailSender.Send(def.AdminstratorMailAddress, def.AdminstratorMailAddress,
                "ǗҌA" + def.Title + "Rec݃|[g",
                sb.ToString(),
                def.SmtpServerHostName, (string[])fileNameList.ToArray(typeof(string)));
        }

        private void sendAutoReport(ItemID itemID)
        {
            SectionDef def = SectionDefManager.GetSectionDef(keyword);

            string uri = WriteLib.CreateMyUri(Request.Url, FileNames.Content, "id=" + itemID.ID);

            Item item = ContentFileAccessLayer.GetItem(itemID);
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("");
            sb.Append(MagSiteLib.Version.MyName);
            sb.Append("莩M郌|[głB\r\n");
            sb.Append(def.Title);
            if (editMode)
            {
                sb.Append("̃RecXV܂B\r\n");
            }
            else
            {
                sb.Append("ɃRec܂܂B\r\n");
            }
            sb.Append("\r\n");

            sb.Append("L[[h: \r\n");
            sb.Append(WriteLib.KeywordToHumanReadableString(keyword));
            sb.Append("\r\n");
            sb.Append("\r\n");

            sb.Append("^Cg: \r\n");
            sb.Append(this.TextBoxTitle.Text);
            sb.Append("\r\n");

            sb.Append("\r\n");

            string digest = item.GetDigestText();
            sb.Append("{̐擪:\r\n");
            int p = 0;
            while (true)
            {
                if (p >= digest.Length) break;
                int lim = Math.Min(p + 36, digest.Length);
                sb.Append(digest.Substring(p, lim - p));
                sb.Append("\r\n");
                p = lim;
            }
            sb.Append("\r\n");

            sb.Append("URL: \r\n");
            sb.Append(uri);
            sb.Append("\r\n");
            sb.Append("\r\n");
            sb.Append("-- \r\n");
            sb.Append(MagSiteLib.Version.PoweredByFullName);
            sb.Append("\r\n");

            MailSender.Send(def.AutoReportMailAddress, def.AdminstratorMailAddress,
                //def.Title + "w" + this.TextBoxTitle.Text + "x",
                "ʒm" + "w" + this.TextBoxTitle.Text + "x",
                sb.ToString(),
                def.SmtpServerHostName, new string[0]);
        }

        protected void ButtonSendFile_Click(object sender, System.EventArgs e)
        {
            if (fixControlCode(this.TextBoxFileTitle, "t@C̐")) return;

            if (FileUpload.PostedFile == null || FileUpload.PostedFile.FileName.Trim().Length == 0)
            {
                this.setErrorMessage("t@Cw肳Ă܂B");
                return;
            }
            bool pngConversionRequested = false;
            string filename = Path.GetFileName(FileUpload.PostedFile.FileName);
            if (Path.GetExtension(filename).ToLower() == ".bmp")
            {
                filename = Path.ChangeExtension(filename, ".png");
                pngConversionRequested = true;
            }
            string fullpath = FileLayout.GetAttachedFileName(this.handlingItemID, filename);
            // Todo: ̓Recɓo^ς݂̃t@CƃobeBOꍇɏύXׂ
            if (File.Exists(fullpath))
            {
                this.setErrorMessage(filename + "͊ɑ݂܂Bt@CςđMĉB");
                return;
            }
            if (this.TextBoxFileTitle.Text.Trim().Length == 0 || this.TextBoxFileTitle.Text.Trim() == fileTitleRequestMessage)
            {
                this.setErrorMessage("t@C̐͂Ă܂B");
                return;
            }

            Size pixelSize = Size.Empty;
            if (pngConversionRequested)
            {
                using (System.Drawing.Image image = System.Drawing.Image.FromStream(FileUpload.PostedFile.InputStream))
                {
                    pixelSize = image.Size;
                    image.Save(fullpath, System.Drawing.Imaging.ImageFormat.Png);
                }
            }
            else
            {
                FileUpload.PostedFile.SaveAs(fullpath);
                if (FileExtentionManager.IsBitmap(fullpath))
                {
                    // SaveAsŕۑĂȉFromFileJĂ̂́A
                    // 󂯎Xg[𖳉HŃt@CɕێŃTCY𒲂ׂ邽
                    // 菜ׂʂł͂Ȃ
                    using (System.Drawing.Image image = System.Drawing.Image.FromFile(fullpath))
                    {
                        pixelSize = image.Size;
                    }
                }
            }

            int number = allocateNewFileNumber();
            Item item = DraftManager.GetItem(this.handlingItemID);
            lock (item)
            {
                ResizeManager.GenerateResizedPictures(item.ItemID, filename, pixelSize.Width);
                item.AddAttahedFile(number, filename, this.TextBoxFileTitle.Text.Trim(), pixelSize, false);
                item.Update();
            }
            this.setNormalMessage("Abv[h");
            this.initializeUpload();
            this.updateListBoxFiles();
        }

        protected void ButtonFileDelete_Click(object sender, System.EventArgs e)
        {
            string selectedValue = this.ListBoxFiles.SelectedValue;
            if (selectedValue.Trim().Length == 0)
            {
                this.setErrorMessage("폜鍀ڂIĂ܂B폜͍s܂B");
                return;
            }
            int number = Item.AttachedFile.ParseNumber(selectedValue);
            // Todo: DraftManageroRŁAt@CƏׂ
            Item item = DraftManager.GetItem(this.handlingItemID);
            lock (item)
            {
                string filename = "";
                foreach (Item.AttachedFile attachedFile in item.AttachedFiles)
                {
                    if (attachedFile.Number == number)
                    {
                        filename = attachedFile.FileName;
                    }
                }
                if (filename.Length == 0)
                {
                    this.setErrorMessage("w肳ꂽt@C܂B폜͍s܂B");
                    return;
                }
                item.RemoveAttahedFile(number);
                item.Update();
                string fullpath = FileLayout.GetAttachedFileName(this.handlingItemID, filename);
                File.Delete(fullpath);
            }
            this.setNormalMessage("[" + selectedValue + "]폜܂B");
            this.updateListBoxFiles();
        }

        protected void ButtonChangeNameOfFile_Click(object sender, System.EventArgs e)
        {
            if (fixControlCode(this.TextBoxFileNewName, "VO")) return;

            string selectedValue = this.ListBoxFiles.SelectedValue;
            if (selectedValue.Trim().Length == 0)
            {
                this.setErrorMessage("OύX鍀ڂIĂ܂BO̕ύX͍s܂B");
                return;
            }
            int number = Item.AttachedFile.ParseNumber(selectedValue);
            Item item = DraftManager.GetItem(this.handlingItemID);
            lock (item)
            {
                string filename = "";
                foreach (Item.AttachedFile attachedFile in item.AttachedFiles)
                {
                    if (attachedFile.Number == number)
                    {
                        filename = attachedFile.FileName;
                    }
                }
                if (filename.Length == 0)
                {
                    this.setErrorMessage("w肳ꂽt@C܂BO̕ύX͍s܂B");
                    return;
                }
                item.RenameNameOfAttahedFile(number, this.TextBoxFileNewName.Text);
                item.Update();
            }
            this.setNormalMessage("[" + selectedValue + "]̖O[" + this.TextBoxFileNewName.Text
                + "]ɕύX܂B");
            this.updateListBoxFiles();
        }

        protected void ButtonDeletePendingTrackBack_Click(object sender, System.EventArgs e)
        {
            string selectedValue = this.ListboxPendingTrackBacks.SelectedValue;
            if (selectedValue.Trim().Length == 0)
            {
                this.setErrorMessage("폜yfBOURLIĂ܂B폜͍s܂B");
                return;
            }

            Item item = DraftManager.GetItem(this.handlingItemID);
            lock (item)
            {
                item.RemovePendingTrackBackUrl(selectedValue);
                item.Update();
            }
            this.setNormalMessage("[" + selectedValue + "]yfBOURL̃Xg폜܂B");
            this.updateListboxPendingTrackBacks();
        }

        protected void ButtonResendPendingTrackBack_Click(object sender, System.EventArgs e)
        {
            string selectedValue = this.ListboxPendingTrackBacks.SelectedValue;
            if (selectedValue.Trim().Length == 0)
            {
                this.setErrorMessage("MΏۂɖ߂yfBOURLIĂ܂BMΏۉ͍s܂B");
                return;
            }

            Item item = DraftManager.GetItem(this.handlingItemID);
            lock (item)
            {
                textboxWaitingTrackBacksIntoItem(item);
                item.MovePendingTrackBackUrlToWaiting(selectedValue);
                item.Update();
            }
            this.setNormalMessage("[" + selectedValue + "]yfBOURL̃XgAgbNobNMΏۂɈړ܂B");
            this.updateListboxPendingTrackBacks();
            this.updateTextBoxWaitingTrackBacks(item);
        }
        protected void ButtonPeruSearchKW_Click(object sender, EventArgs e)
        {
            this.TextBoxCurrentSearchPage.Text = "1";
            this.keyword = GeneralContentsHandler.GetItem(this.handlingItemID).Keyword;
            SectionDef def = SectionDefManager.GetSectionDef(this.keyword);
            peruSearch(this.TextBoxPeruSearchKeyword.Text, null, def.PeruAssociateID);
        }

        private void buildPeruSearchNavigationSub(System.Text.StringBuilder sb, int page)
        {
            sb.AppendFormat("[<a href='javascript:searchNav({0})'>{0}</a>]", page);
        }

        private void buildPeruSearchNavigation(System.Text.StringBuilder sb, int totalPages)
        {
            if (totalPages == 1) return;
            sb.Append("<p>");
            int currentPage = int.Parse(this.TextBoxCurrentSearchPage.Text);
            int startPage = Math.Max(1, currentPage - 5), endPage = Math.Min(totalPages, currentPage + 5);
            if (startPage != 1) buildPeruSearchNavigationSub(sb, 1);
            for (int page = startPage; page <= endPage; page++)
            {
                if (page == currentPage) sb.Append("");
                buildPeruSearchNavigationSub(sb, page);
                if (page == currentPage) sb.Append("");
            }
            if (endPage < totalPages) sb.Append("");
            sb.Append("</p>");
        }

        private void peruSearch(string keywords, string title, string associateId)
        {
            int page;
            if (!int.TryParse(this.TextBoxCurrentSearchPage.Text, out page)) page = 1;

            XElement root;
            try
            {
                var client = new System.Net.WebClient();
                client.Headers.Add("user-agent", MagSiteLib.Version.FullName);

                byte[] resultArray = client.DownloadData(QueryPeruAsin.CreateUriOfItemSearch(this.DropDownListPeruSearchIndex.Text, keywords, title, page, associateId));

                root = XElement.Load(new XmlTextReader(new MemoryStream(resultArray)));
            }
            catch (Exception ex)
            {
                setMessage("", ex.ToString());
                return;
            }
            XNamespace peru = MagSiteLib.XmlNamespaces.Peru;

            var q = from item in root.Descendants(peru + "Item")
                    select new
                    {
                        asin = item.Element(peru + "ASIN").Value,
                        detailPageURL = item.Element(peru + "DetailPageURL").Value,
                        productGroup = item.Element(peru + "ItemAttributes").Element(peru + "ProductGroup").Value,
                        title = item.Element(peru + "ItemAttributes").Element(peru + "Title").Value,
                        pictureURL = item.Element(peru + "SmallImage") != null ? item.Element(peru + "SmallImage").Element(peru + "URL").Value : null,
                    };

            System.Text.StringBuilder sb = new System.Text.StringBuilder();

            if (root.Descendants(peru + "Error").Count() > 0)
            {
                sb.AppendFormat("<p>Error: {0}</p>", HttpUtility.HtmlEncode(root.Descendants(peru + "Message").ToArray()[0].Value));
            }

            var qTotalResults = from item in root.Descendants(peru + "TotalResults") select int.Parse(item.Value);
            int totalResults = 0;
            foreach (var n in qTotalResults) totalResults = n;

            var qTotalPages = from item in root.Descendants(peru + "TotalPages") select int.Parse(item.Value);
            int totalPages = 1;
            foreach (var n in qTotalPages) totalPages = n;

            buildPeruSearchNavigation(sb, totalPages);

            sb.Append("<table style='width: 95%'><tr><th>GRP</th><th>asin</th><th>title</th><th>MagML</th><th>picture</th></tr>");
            foreach (var item in q)
            {
                sb.AppendFormat("<tr><td>{0}</td><td>{1}</td><td><a href='{2}' target='_blank' >{3}</a></td>", item.productGroup, item.asin, HttpUtility.HtmlEncode(item.detailPageURL), HttpUtility.HtmlEncode(item.title));
                sb.AppendFormat("<td><input type='button' id='addasin' value='asinǉ' onclick='javascript:insertAsin(\"asin\",\"{0}\");'><br>", item.asin);
                sb.AppendFormat("<input type='button' id='addasinr' value='asinrǉ' onclick='javascript:insertAsin(\"asinr\",\"{0}\");'></td>", item.asin);
                if (item.pictureURL != null) sb.AppendFormat("<td><img src='{0}'></td>", HttpUtility.HtmlEncode(item.pictureURL));
                sb.AppendFormat("</tr>");
            }
            sb.Append("</table>");

            buildPeruSearchNavigation(sb, totalPages);

            sb.AppendFormat("<p>TotalResults: {0} TotalPages: {1}</p>", totalResults, totalPages);

            this.LabelPreview.Text = sb.ToString();
        }
        protected void ButtonPeruSearchContinue_Click(object sender, EventArgs e)
        {
            this.keyword = GeneralContentsHandler.GetItem(this.handlingItemID).Keyword;
            SectionDef def = SectionDefManager.GetSectionDef(this.keyword);
            peruSearch(this.TextBoxPeruSearchKeyword.Text, null, def.PeruAssociateID);
        }
        protected void ButtonFixParams_Click(object sender, EventArgs e)
        {
            var sb = new System.Text.StringBuilder();
            var reader = new StringReader(this.TextBoxBody.Text);
            for (; ; )
            {
                string s = reader.ReadLine();
                if (s == null) break;
                // $$ref http://mag.autumn.org/Content.modf?id=20091102010033  $$ref 20091102010033
                s = Regex.Replace(s, "(?<ref>\\$\\$ref)[ \t]+.+?(?<id>\\d{14})", "${ref} ${id}");
                // $$asin[r] http://cc/B00005F6IN/cc   $$asin[r] B00005F6IN
                s = Regex.Replace(s, "(?<asin>\\$\\$asinr?)[ \t]+.+?(?<id>[0-9a-zA-Z]{10,13}).*", "${asin} ${id}");
                sb.AppendLine(s);
            }
            this.TextBoxBody.Text = sb.ToString();
        }
    }
}
